;##############################################
;##                                          ##
;##                 10                 ##
;##                              ##
;##                                          ##
;##############################################


;-------------------------  

.include "tn2313def.inc"	;   
.list					;  

.def	drebL = R1		;    
.def	drebH = R2		;    
.def	temp = R16		;  
.def	data = R17		;   
.def	flz = R18		;  
.def	count = R19		;   
.def	addre = R20		;    EEPROM
.def	codL = R21		;     
.def	codH = R22		;     

;-------------------------  

.equ	bsize = 60		;     
.equ	kzad  = 3000	;  
.equ	kandr = 20		;  


;-------------------------    (SRAM)

		.dseg			;   
		.org	0x60	;    

bufr:	.byte	bsize	;    


;-------------------------     (EEPROM)

		.eseg			;   EEPROM
		.org	0x08	;    

klen:	.byte	1		;      
bufe:	.byte	bsize	;    



;-------------------------   

		.cseg 			;    
		.org	0		;     

start:	rjmp	init	;    
		reti			;   0
		reti			;   1
		reti			; / 1, 
		rjmp	propr	; / 1, ,  A
		rjmp	propr	;    T1
		reti			;    T0
		reti			;  UART  
		reti			;  UART   
		reti			;  UART  
		reti			;   
		reti			;      
		reti			; / 1. ,  B 
		reti			; / 0. ,  B 
		reti			; / 0. ,  A 
		reti			; USI  
		reti			; USI 
		reti			; EEPROM 
		reti			;   


;******************************************************
;*                                                    *
;*                                 *
;*                                                    *
;******************************************************
init:

;--------------------------  
	
		ldi		temp, RAMEND	;     
		out		SPL, temp		;     

;--------------------------   /
	
		ldi		temp,0x18		;   PB
		out		DDRB,temp
		ldi		temp,0xE7
		out		PORTB,temp

		ldi		temp, 0x7F		;   PD
		out		PORTD, temp
		ldi		temp, 0
		out		DDRD, temp

;---------------------------  () 

		ldi 	temp, 0x80
		out		ACSR, temp

;---------------------------  

		ldi		temp,high(kzad)	;   
		out		OCR1AH,temp
		ldi		temp,low(kzad)
		out		OCR1AL,temp
		ldi		temp,0x03		;   
		out		TCCR1B,temp



;******************************************************
;*                                                    *
;*                             *
;*                                                    *
;******************************************************
main:
		ldi		codL,0x7F		;    (. )
		ldi		codH,0x07		;    (. )

m0:		rcall	incod			;     
		brne	m0				;     ,  

m1:		rcall	incod			;  
		breq	m1				;     ,  

m2:		ldi		ZH,high(bufr)	;  
		ldi		ZL,low(bufr)	;   
		clr		count			;   

;----------------------   

m3:		cli					;   
		ldi		data,1		;    
		rcall	wait		;   

m5:		rcall	incod		;     
		st		Z+,XL		;    
		st		Z+,XH
		inc		count		;   
		inc		count
		cpi		count,bsize	;     
		brsh	m7			;  ,   

		mov		codL,XL		;    
		mov		codH,XH

		ldi		data,2		;     (  )
		rcall	wait

m6:		rcall	incod		;     
		brne	m3			;  ,   
		cpi		flz,1		;     
		brne 	m6

m7:		sbic	PINB,7		;   
		rjmp	m9			;    

; -----------------------------   

		mov 	data,count		;     data
		ldi		addre,klen		;    
		rcall	eewr			;     EEPROM

		ldi		addre,bufe		;       EEPROM
		ldi		ZH,high(bufr)	;    Z 
		ldi		ZL,low(bufr)	;     

m8:		ld		data, Z+	;     
		rcall	eewr		;    EEPROM
		dec		count		;   
		brne	m8			;   ,  			

		rjmp	m11			;    		


; -----------------------------   
m9:
		ldi		addre,klen	;     
		rcall	eerd		;     EEPROM
		cp		count,data	;    
		brne	m13			;   ,  

		ldi		addre,bufe		;  YL    EEPROM
		ldi		ZH,high(bufr)	;    Z 
		ldi		ZL,low(bufr)	;     

m10:	rcall	eerd		;     EEPROM 
		ld		temp,Z+		;      

		cp		data,temp	;     
		brne 	m13			;   ,   

		dec		count		;    
		brne	m10			;   ,  


; -----------------------------  
m11:		
		sbi		PORTB,4		;  " "
		ldi		data,3		;    
		rcall	wait
		cbi		PORTB,4		;  " "

m13:	rjmp	main


;******************************************************
;*                                                    *
;*                            *
;*                                                    *
;******************************************************

; ------------------------------    2   
incod:	push	count

		ldi		XL,0		;    X
		ldi		XH,0

ic1:	ldi		count,kandr	;  
		mov		drebL,XL	;    
		mov		drebH,XH	;    

ic2:	in		XL,PIND		;   ( )
		cbr		XL,0x80		;  
		in		XH,PINB		;   ( )
		cbr		XH,0xF8		;  

ic3:	cp		XL,drebL	;   
		brne	ic1			;   ,   
		cp		XH,drebH	;   
		brne	ic1			;   ,   

ic4:	dec		count		;   
		brne	ic2			;    , 

		cp		XL,codL		;    
		brne	ic5
		cp		XH,codH

ic5:	pop		count
		ret


; ------------------------------  
wait:
		cpi		data,1			;   
		brne	w1
		ldi		temp,0x40 		;     
		rjmp	w2
w1:		ldi		temp,0x80 		;    

w2:		out		TIMSK,temp		;  
		clr 	temp			;  
		out		TCNT1H,temp
		out		TCNT1L,temp

		ldi		flz,0		;   
		sei					;  
		cpi		data,2		;    2- 
		breq	w4			;  

w3:		cpi		flz,1		;   
		brne 	w3

		cli					;  

w4:		ret


; ------------------------------     EEPROM
eewr:
		cli						;  
		sbic 	EECR,EEWE		;   EEPROM
		rjmp	eewr			;    
		out		EEAR,addre		;     
		out		EEDR,data		;     
		sbi		EECR,EEMWE		;    
		sbi		EECR,EEWE		;   
		inc		addre			;    EEPROM
		ret

; ------------------------------     EEPROM
eerd:	
		cli						;  
		sbic	EECR,EEWE		;   EEPROM
		rjmp	eerd			;    
		out		EEAR,addre		;     
		sbi		EECR,EERE		;    
		in		data, EEDR		;     data
		inc		addre			;    EEPROM
		ret



;******************************************************
;*                                                    *
;*                        *
;*                                                    *
;******************************************************

propr:	ldi		flz,1		;   
		reti				;   




