;##############################################
;##                                          ##
;##                 9                  ##
;##                       ##
;##                                          ##
;##############################################


;-------------------------  

.include "tn2313def.inc"	;   
.list					;  

.def	temp = R16		;  
.def	temp1 = R17		;   
.def	count = R18		;  -
.def	fnota = R19		;   
.def	dnota = R20		;   
.def	loop = R21		;    

;-------------------------   

		.cseg 			;    
		.org	0		;     

start:	rjmp	init	;    
		reti			;   0
		reti			;   1
		reti			;     T1
		reti			;    T1
		reti			;    T1
		reti			;    T0
		reti			;  UART  
		reti			;  UART   
		reti			;  UART  
		reti			;   
		reti			;      
		reti			; / 1.  B 
		reti			; / 0.  B 
		reti			; / 0.  A 
		reti			; USI  
		reti			; USI 
		reti			; EEPROM 
		reti			;   


;******************************************************
;*                                                    *
;*                                 *
;*                                                    *
;******************************************************
init:

;--------------------------  
	
		ldi		temp, RAMEND	;     
		out		SPL, temp		;     

;--------------------------   /
	
		ldi 	temp, 0x08		;   PB
		out		PORTB, temp
		out		DDRB, temp

		ldi 	temp, 0x7F		;   PD
		out		PORTD, temp
		ldi		temp, 0x00
		out		DDRD, temp

;---------------------------  () 

		ldi 	temp, 0x80
		out		ACSR, temp


;---------------------------   T1

		ldi 	temp, 0x09		;   CTC
		out		TCCR1B, temp
m1:		ldi 	temp, 0x00		;  
		out		TCCR1A, temp


;******************************************************
;*                                                    *
;*                             *
;*                                                    *
;******************************************************
main:

;--------------------------    

		clr 	count		;    
		in		temp, PIND	;   D		
m2:		lsr 	temp		;   
		brcc 	m3			;      0
		inc		count		;   
		cpi		count, 7	;  (7 -  )
		brne	m2			;   , 
		rjmp	m1			;      

;--------------------------  
m3:
		mov		YL, count		;  , 
		ldi		ZL, low(tabm*2)	;   
		ldi		ZH, high(tabm*2)
		rcall	addw			;   16- 

		lpm		XL, Z+			;    
		lpm		XH, Z			;    X

;---------------------------  

m4:		mov		ZH, XH			;   Z  
		mov		ZL, XL

m5:		in		temp, PIND		;    D		
		cpi		temp, 0x7F		;    7FH
		breq	m1				;   ( )  

		lpm		temp, Z			;   
		cpi		temp, 0xFF		;     
		breq	m4				;  ,   

		andi	temp, 0x1F		;    
		mov		fnota, temp		;     
		lpm		temp, Z+		;     
		rol		temp			;  ,    
		rol		temp			;   
		rol		temp
		rol		temp
		andi	temp, 0x07		;    
		mov		dnota, temp		;     

		rcall	nota			;    

		rjmp	m5				;    ( )





;******************************************************
;*                                                    *
;*                         *
;*                                                    *
;******************************************************

; ----------------------  16-  
addw:	push	YH
		
		lsl		YL				;     2
		ldi		YH, 0			;     = 0
		add		ZL, YL			;   
		adc		ZH, YH

		pop		YH
		ret

;-----------------------    
nota:	push	ZH
		push	ZL
		push	YL
		push	temp

		cpi		fnota, 0x00		;    
		breq	nt1				;  ,    

		mov		YL, fnota		;  ,  
		ldi		ZL, low(tabkd*2)	;     
		ldi		ZH, high(tabkd*2)
		rcall	addw			;   16- 

		lpm		temp, Z+		;  . .    
		lpm		temp1, Z		;  . .    
		out		OCR1AH, temp1	;   .   
		out		OCR1AL, temp	;   .   

		ldi		temp, 0x40		;  
		out		TCCR1A, temp

nt1:	rcall	wait			; 

		ldi		temp, 0x00		;  
		out		TCCR1A, temp

		ldi		dnota,0			;   
		rcall	wait			;   

		pop		temp
		pop		YL
		pop		ZL
		pop 	ZH
		ret

;-----------------------  
wait:	push	ZH
		push	ZL
		push	YH
		push	YL

		mov		YL, dnota		;  ,  
		ldi		ZL, low(tabz*2)	;   
		ldi		ZH, high(tabz*2)
		rcall	addw			;   16- 

		lpm		YL, Z+			;     
		lpm		YH, Z			;     

		clr		ZL				;    Z
		clr		ZH

		;  
w1:		ldi		loop,255		;   
w2:		dec		loop
		brne 	w2
		adiw	R30, 1			;    Z  
		cp		YL, ZL			;   
		brne	w1
		cp		YH, ZH			;   
		brne	w1

		pop		YL				;  
		pop		YH
		pop		ZL
		pop 	ZH
		ret




;******************************************************
;*                                                    *
;*                                     *
;*                                                    *
;******************************************************

tabz:   .dw      128,256,512,1024,2048,4096,8192


;******************************************************
;*                                                    *
;*                         *
;*                                                    *
;******************************************************

tabkd:	.dw		0
		.dw		4748,4480,4228,3992,3768,3556,3356,3168,2990,2822,2664,2514
		.dw		2374,2240,2114,1996,1884,1778,1678,1584,1495,1411,1332,1257
		.dw		1187,1120,1057, 998, 942, 889, 839, 792


;******************************************************
;*                                                    *
;*                             *
;*                                                    *
;******************************************************

tabm:	.dw		mel1*2,mel2*2,mel3*2,mel4*2
		.dw		mel5*2,mel6*2,mel7*2


;******************************************************
;*                                                    *
;*                                      *
;*                                                    *
;******************************************************

;           
mel1:	.db		109,104,109,104,109,108,108, 96,108,104 
		.db		108,104,108,109,109, 96,109,104,109,104 
		.db		109,108,108, 96,108,104,108,104,108,141 
		.db		 96,109,111, 79, 79,111,111,112, 80, 80 
		.db		112,112,112,111,109,108,109,109, 96,109 
		.db		111, 79, 79,111,111,112, 80, 80,112,112 
		.db		112,111,109,108,141,128, 96,255 

;          
mel2:	.db		109,110,141,102,104,105,102,109,110,141 
		.db		104,105,107,104,109,110,141,104,105,139 
		.db		109,110,173, 96,114,115,146,109,110,112 
		.db		109,114,115,146,107,109,110,114,112,110 
		.db		146,109,105,136,107,105,134,128,128,102 
		.db		105,137,136,128,104,107,139,137,128,105 
		.db		109,141,139,128,110,109,176,112,108,109 
		.db		112,144,142,128,107,110,142,141,128,105 
		.db		109,139,128,173,134,128,128,109,112,144 
		.db		142,128,107,110,142,141,128,105,109,139 
		.db		128,173,146,128, 96,255

;           
mel3:	.db		132,141,141,139,141,137,132,132,132,141 
		.db		141,142,139,176,128,144,146,146,154,154 
		.db		153,151,149,144,153,153,151,153,181,128 
		.db		 96,255

;        Happy births to you
mel4:	.db		107,107,141,139,144,143,128,107,107,141
		.db		139,146,144,128,107,107,151,148,146,112
		.db		111,149,117,117,148,144,146,144,128,255

;          
mel5:	.db		 99,175,109,107,106,102, 99,144,111,175 
		.db		 96, 99,107,107,107,107,102,104,170, 96 
		.db		 99,109,109,109,109,107,106,143,109,141 
		.db		 99,109,109,109,109,104,106,171, 96, 99 
		.db		111,109,107,106,102, 99,144,111,143,104 
		.db		114,114,114,114,109,111,176, 96,104,116 
		.db		112,109,107,106, 64, 73,143,107,131, 99 
		.db		144, 80, 80,112,111, 64, 75,173,128,255

;          " "
mel6:	.db		105,109,112,149,116, 64, 80,148,114, 64 
		.db		 78,146,112, 96,105,105,109,144,111, 64 
		.db		 80,145,112, 64, 81,178, 96,117,117,117 
		.db		149,116, 64, 82,146,112, 64, 79,146,144 
		.db		 96,105,105,107,141,108,109,112,110,102 
		.db		104,137,128, 96,105,105,105,137,102, 64 
		.db		 73,142,105,107,109, 64, 75,137, 96,105 
		.db		105,105,137,102,105,142,112, 64, 82,180 
		.db		 96,116,116,116,148,114,112,142,109, 64 
		.db		 78,146,144, 96,105,105,107,141,108,109 
		.db		112,110,102,104,169, 96, 96,255

;        
mel7:	.db		107,104,141,139,102,105,104,102,164,128 
		.db		104,107,109,109,109,111,114,112,111,109 
		.db		144,139,128,109,111,144, 96,111,109,104 
		.db		107,105,173,128,111,109,112,107,111,109 
		.db		109,107,102,104,134,132,128,100,103,107
		.db		107,107,107,139,112,100,103,102,102,102 
		.db		134,102,103,107,105,107,108,108,108,108 
		.db		107,105,107,108,144,142,128,112,107,110 
		.db		140,112,105,108,107,107,107,105,140,139 
		.db		139,112,103,102,103,105,108,107,105,103 
		.db		128,112,107,110,108,108,108,140,112,105 
		.db		108,107,107,107,139,112,103,102,103,105 
		.db		108,107,105,103,105,139,132,128, 96, 96 
		.db		 96,255

;        
;mel8:	.db		102,105,141,107,105,141, 96,107,171, 96 
;		.db		104,105,139,104,105,166,128,160,109,110 
;		.db		144,110,109,144, 96,110,174,128,110,112 
;		.db		146,112,114,205,117,117,149,116,114,149
;		.db		 96,116,174,128,110,112,146,112,114,205 
;		.db		128,102,105,141,107,105,141, 96,107,171 
;		.db		128,104,105,139,104,105,166,128,128,117 
;		.db		117,149,116,114,149, 96,116,174,128,110
;		.db		112,146,112,114,205,128,102,105,141,107 
;		.db		105,141, 96,107,171,128,104,105,139,104
;		.db		105,166,128,128, 96,255 

